import  java.io.*;
import  java.util.Scanner;

class node { 
   String info; 
   node next; 
} 

public class LinkedList { 

  public static String readInfo () {
    Scanner in = new Scanner(System.in);    
    System.out.print("Insert value: ");
    String info = in.next();
    return info;
  }
 
  public static void init (node lis) {
    lis = null;
  }

  public static boolean isEmpty (node lis) { 
      return (lis == null);
  }
  
  public static node insertFirst(node lis, String s) { 
    node p = new node();  
    p.info = s;  
    p.next = lis; 
    return p; 
  } 

  public static node insertLast(node lis, String s) { 
     node p = new node(); 
     p.info = s; // note: p.next is not initialized in the constructor 
                 // and hence it is true that (p.next == null) 
     if (lis == null) return p; 
     else { 
       node last = lis; 
       while (last.next != null) 
         last = last.next; 
       last.next = p; 
       return lis; 
     } 
  } 

  public static node deleteFirst(node lis) { 
    if (lis != null) 
      lis = lis.next; 
    return lis; 
  }  

  public static node delete(node lis, String s) { 
     node p = new node(); // create the generator node 
     p.next = lis; 
     lis = p; 

     boolean found = false; 
     while ((p.next != null) && !found) { 
       if (p.next.info.equals(s)) { 
         p.next = p.next.next; // delete the element 
         found = true; // forces exit of the loop 
       } 
       else p = p.next; 
     } return lis.next; // delete generator node 
  } 
  
  public static void print(node lis) { 
    node p = lis; 
    while (p != null) { 
        System.out.printf(" %s ", p.info); 
      p = p.next;
    } 
    System.out.println(); 
  } 
  
  public static int search(node lis, String s) { 
    int pos = 0;
    while (lis != null) { 
      pos++;
      if (lis.info.equals(s)) 
        return pos; 
      lis = lis.next; 
    } return -1; 
  } 

  
  public static void main(String args[]) {
      Scanner in = new Scanner(System.in);  
      node lis= null;
      String info = null;
      int pos = -1;
      
      char option = 'a';
      String opt = null;
      init(lis);
      do {
	    System.out.println("Options:");
	    System.out.println(" e: check if the list is empty");
	    System.out.println(" i: insert new element at the beginning");
	    System.out.println(" l: insert new element at the end");
	    System.out.println(" d: delete the top element");
	    System.out.println(" r: delete the first element with info");
	    System.out.println(" s: search an element");
	    System.out.println(" p: print list");
          opt = in.next(); option = opt.charAt(0);
          switch (option) {
	    case 'e': 
	      if (isEmpty(lis))
                 System.out.println("The list is empty");
              else
                 System.out.println("The list is not empty");
		break;
	    case 'i': 
              info = readInfo();
              lis= insertFirst(lis,info);
		break;
	    case 'l': 
              info = readInfo();
              lis= insertLast(lis,info);
		break;
	    case 'r': 
              info = readInfo();
              lis= delete(lis,info);
		break;
	    case 's': 
              info = readInfo();
              pos= search(lis,info);
              if (pos==-1)
                 System.out.println("Not found");
              else
                 System.out.printf("Found in the %d-th position\n",pos);
		break;
	    case 'd': 
              lis= deleteFirst(lis);
		break;
	    case 'p': 
              print(lis);
		break;
	    }
	} while (
         option == 'e' || 
         option == 'i' || 
         option == 'l' || 
         option == 'd' || 
         option == 'r' || 
         option == 's' || 
         option == 'p' 
        );
  }
}  
