import  java.io.*;
import  java.util.Scanner;

public class QueueArray {

    static private int size = 1000;
    static private int head;
    static private int tail;
    static private String [] queue;

   public static String readInfo () {
     Scanner in = new Scanner(System.in);    
     System.out.print("Insert value: ");
     String info = in.next();
     return info;
   }

    private static int next (int n) {
	return ((n==queue.length-1) ? 0 : n+1);
    }

    public static void init() {
	head = tail = 0;
	queue = new String[size];
    }

    public static boolean isEmpty() {
	return (head == tail);
    }

    public static boolean isFull() {
        return (next(tail)==head);
    }

    public static void enqueue(String x) {
        if (!isFull()) {
	   queue[tail] = x;
           tail=next(tail);
	}
    }

    public static String dequeue() {
        if (!isEmpty()) {
  	   String t = queue[head];
           head = next(head);
	   return t;
	}
        else
	  return null;
    }

    static void print () 
    {
       int i;
       for (i=head;i!=tail;i=next(i)) 
           System.out.printf(" %s ", queue[i]);          
       System.out.println(); 
    }

  public static void main(String args[]) {
      Scanner in = new Scanner(System.in);  
      String info = null;
      int pos = -1;
      
      char option = 'a';
      String opt = null;
      init();
      do {
	    System.out.println("Options:");
	    System.out.println(" e: check if the list is empty");
	    System.out.println(" i: insert a new element");
	    System.out.println(" d: delete the first-inserted element");
	    System.out.println(" p: print list");
          opt = in.next(); option = opt.charAt(0);
          switch (option) {
	    case 'e': 
	      if (isEmpty())
                 System.out.println("The queue is empty");
              else
                 System.out.println("The queue is not empty");
		break;
	    case 'i': 
              info = readInfo();
              enqueue(info);
		break;
	    case 'd': 
              info= dequeue();
              if (info != null)
                 System.out.println(info);
	      break;
	    case 'p': 
              print();
		break;
	    }
	} while (
         option == 'e' || 
         option == 'i' || 
         option == 'd' || 
         option == 'p' 
        );
  }


}
