import  java.io.*;
import  java.util.Scanner;

class node { 
   String info; 
   node next; 
} 

public class RecLinkedList { 

  public static String readInfo () {
    Scanner in = new Scanner(System.in);    
    System.out.print("Insert value: ");
    String info = in.next();
    return info;
  }
 
  public static void init (node lis) {
    lis = null;
  }

  public static boolean isEmpty (node lis) { 
      return (lis == null);
  }
  
  public static node insertFirst(node lis, String s) { 
    node p = new node();  
    p.info = s;  
    p.next = lis; 
    return p; 
  } 


    // recursive version
  public static node insertLast(node lis, String s) { 
    if (lis == null) { 
       node res = new node(); // note: res.next == null 
       res.info = s; 
       return res; 
    } else { 
       lis.next = insertLast(lis.next, s); 
       return lis; 
    } 
  } 

  public static node deleteFirst(node lis) { 
    if (lis != null) 
      lis = lis.next; 
    return lis; 
  }  


    // recursive version
  public static node delete(node lis, String s) { 
    if (lis == null) 
       return lis;
    if (lis.info.equals(s))
       return lis.next;
    lis.next = delete(lis.next,s);
    return lis;
  }
 
 
    // recursive version
  public static void printList(node lis) { 
    if (lis == null) 
      System.out.println(); 
    else { 
      System.out.printf(" %s ", lis.info); 
      printList(lis.next);
    }     
  } 
  

    // recursive version
  public static int search(node lis, String s) { 
    if (lis == null) 
      return -1;
    if (lis.info.equals(s)) 
      return 1; 
    int pos = search(lis.next,s);
    if (pos == -1)
      return -1;
    else 
      return pos+1;
  }   

    

  public static void main(String args[]) {
      Scanner in = new Scanner(System.in);  
      node lis= null; //a reference to the first node
      String info = null;
      int pos = -1;
      
      char option = 'a';
      String opt = null;
      init(lis);
      do {
	    System.out.println("Options:");
	    System.out.println(" e: check if the list is empty");
	    System.out.println(" i: insert new element at the beginning");
	    System.out.println(" l: insert new element at the end");
	    System.out.println(" d: delete the top element");
	    System.out.println(" r: delete the first element with info");
	    System.out.println(" s: search an element");
	    System.out.println(" p: print list");
          opt = in.next(); option = opt.charAt(0);
          switch (option) {
	    case 'e': 
	      if (isEmpty(lis))
                 System.out.println("The list is empty");
              else
                 System.out.println("The list is not empty");
		break;
	    case 'i': 
              info = readInfo();
              lis= insertFirst(lis,info);
		break;
	    case 'l': 
              info = readInfo();
              lis= insertLast(lis,info);
		break;
	    case 'r': 
              info = readInfo();
              lis= delete(lis,info);
		break;
	    case 's': 
              info = readInfo();
              pos= search(lis,info);
              if (pos==-1)
                 System.out.println("Not found");
              else
                 System.out.printf("Found in the %d-th position\n",pos);
		break;
	    case 'd': 
              lis= deleteFirst(lis);
		break;
	    case 'p': 
              printList(lis);
		break;
	    }
	} while (
         option == 'e' || 
         option == 'i' || 
         option == 'l' || 
         option == 'd' || 
         option == 'r' || 
         option == 's' || 
         option == 'p' 
        );
  }
}  
